{{
     This is a sample/test application for basic Xbee 900 HP API mode 1 functionality.
     It does not handle API mode 2 (escaped characters) yet.  It will, eventually.

}}


OBJ
      xb: "XB_HP_Driver 2" 
CON
  _clkmode = xtal1 + pll16x 'Standard clock mode * crystal frequency = 80 MHz
  _xinfreq = 5_000_000

VAR

     long ptr

DAT
     rf_data     byte $0[256],0         'Contents of this buffer will be inserted into the API packet.

     broadcast_     byte $0 , $0 , $0 , $0 , $0 , $0 , $FF , $FF , 0  'Broadcast Address

     module_00      byte $0[43],0       'Local module: SH is at [2]-[5], SL is at [6]-[9]
     module_01      byte $0[43],0       'Remote modules: SH is at [2]-[5], SL is at [6]-[9]
     module_02      byte $0[43],0       'This section will hold key information about each module
     module_03      byte $0[43],0       'found when a ND packet is sent (Network Discovery)
     module_04      byte $0[43],0
     module_05      byte $0[43],0
     module_06      byte $0[43],0
     
pub Main 

     xb.Start

     delay(2000)

     'Let's fill module_02 SH and SL address with a dummy value for testing.

     module_02[2] := $A1
     module_02[3] := $A2
     module_02[4] := $A3
     module_02[5] := $A4
     module_02[6] := $C0
     module_02[7] := $C1
     module_02[8] := $C2
     module_02[9] := $C3

          'xb.network_discover(@module_00,7)  'Can't test this, no modules to hook up yet.
                              'First module to populate, Total # of modules to populate

          xb.type_08_query( string("BD") )
                                 'command
               delay(1000)

          xb.type_08_write_val( string("PL") , 12 , 13 , 14 , 15 )
                                    'command,  msb to lsb of value
               delay(1000)

          xb.type_08_write_string( string("PL") , string("AAAA") )
                                      'command,    string to send
               delay(1000)


          Add_Payload( string("AB") )

          Add_Payload( string("zzzzzz") ) 
          
          xb.type_10_request( @Module_02[2] , 12 , %0000_0011 , @rf_data )

          Empty_Payload   


               delay(1000)
      

          Add_Payload(string("ABCDDCBA") )

          xb.type_11_request( @broadcast_, $A1 , $A2 , $A3 , $A4 , $0D ,   %0000_0011 , @rf_data )     
                              'address    src   dest  clust prof  radius   option       data
          Empty_Payload    

               delay(1000)

          xb.type_17_query( @Module_02[2] , string("BD") )

               delay(1000)

          xb.type_17_write_val( @broadcast_ , string("BD") , $AABBCCDD , $EEFF1122 , $FE1111BA , $FE1111BA)

               delay(1000)

          xb.type_17_write_string( @Module_02[2] , string("BD") , string("AAAA") )

               delay(1000)

          if xb.type_88_read(xb.type_08_write_string( string("PL") , string("AAAA") ) ) => 0

               'If we get here, our packet was sent and a response was received.
               

pub Empty_Payload

    bytefill(@rf_data, 0, ptr)

    ptr := 0

pub Add_Payload(data)

  bytemove(@rf_data + ptr , data , strsize(data) )'(Destination,Source,Length)

  ptr += strsize(data)

  return ptr

pri Delay(Time) | AutoTime, Cycle                     'Wait amount of time before continuing
{{
  Here, we pause as needed for amount of time specified in milliseconds.
}}
                                 
  Cycle:=cnt                     
  AutoTime:=clkfreq/1000 * Time   
  waitcnt(Cycle+=AutoTime)       